
; ID CPU CORE
; VERSION: E.01, Preliminary
;
; Written by DednDave, January 2010

        INCLUDE \masm32\include\masm32rt.inc
        .586

; .586 or higher required for the CPUID instruction with MASM
; (even though the instruction was introduced pre-586)
; otherwise, it can be hard-coded as 0Fh,0A2h

;*********************************************************

;prototype

IdCpu   PROTO   :DWORD

;*********************************************************


;*********************************************************

;cpu type info data structure

CpuTypeInfo     STRUCT
  cbSize        DD ?                     ;structure size in bytes (input)
  dwCoreAffMask DD ?                     ;selected core affinity mask (input)
  dwIdCpuStatus DD ?                     ;cpu core identification status
  bVendorID     DB ?                     ;vendor ID number
  bFamily       DB ?                     ;cpu family
  bExtFamily    DB ?                     ;cpu extended family
  bModel        DB ?                     ;cpu model
  bExtModel     DB ?                     ;cpu extended model
  bType         DB ?                     ;cpu type
  bStep         DB ?                     ;cpu step
  bMmxBits      DB ?                     ;MMX bits
  w3DNowBits    DW ?                     ;3DNow bits
  wSseBits      DW ?                     ;SSE bits
  dwMiscBits    DD ?                     ;misc bits
  szBrand       DB 50 DUP(?)             ;brand string
  szVendor      DB 14 DUP(?)             ;vendor string
  szMmx         DB 8 DUP(?)              ;MMX string
  sz3DNow       DB 10 DUP(?)             ;3DNow string
  szSse         DB 10 DUP(?)             ;SSE string
CpuTypeInfo     ENDS

;*********************************************************

;--------------------------------------------------------------------------------------------

        .DATA

BinTerm DB 'b',13,10,0

        .DATA?

        ALIGN   4
CpuTInfo CpuTypeInfo <>

BinBuf  DB 33 DUP(?)

;--------------------------------------------------------------------------------------------

        .CODE

_main   PROC

        mov dword ptr CpuTInfo.cbSize,sizeof CpuTInfo ;set the structure size value
        mov dword ptr CpuTInfo.dwCoreAffMask,1        ;select core 0
        INVOKE  IdCpu,offset CpuTInfo                 ;pass the address of the structure

        push    eax
        push    edx
        push    ecx
        push    eax

;EAX

        print   chr$('          EAX: ')
        pop     eax
        print   ustr$(eax),13,10

;ECX

        print   chr$('          ECX: ')
        pop     eax
        print   ustr$(eax),13,10

;EDX

        print   chr$('          EDX: ')
        pop     eax
        print   uhex$(eax),'h',13,10

;exit if EAX return status is non-zero

        pop     ecx                      ;ECX = return status
        jecxz   Continue

        jmp     ExitMain

Continue:

;cbSize

        print   chr$('       cbSize: ')
        print   ustr$(CpuTInfo.cbSize),13,10

;dwCoreAffMask

        print   chr$('dwCoreAffMask: ')
        INVOKE  dw2bin_ex,
                CpuTInfo.dwCoreAffMask,
                offset BinBuf
        print   offset BinBuf
        print   offset BinTerm

;dwIdCpuStatus

        print   chr$('dwIdCpuStatus: ')
        print   uhex$(CpuTInfo.dwIdCpuStatus),'h',13,10

;bVendorID

        print   chr$('    bVendorID: ')
        movzx   eax,byte ptr CpuTInfo.bVendorID
        print   ustr$(eax),13,10

;bFamily

        print   chr$('      bFamily: ')
        movzx   eax,byte ptr CpuTInfo.bFamily
        print   ustr$(eax),13,10

;bExtFamily

        print   chr$('   bExtFamily: ')
        movzx   eax,byte ptr CpuTInfo.bExtFamily
        print   ustr$(eax),13,10

;bModel

        print   chr$('       bModel: ')
        movzx   eax,byte ptr CpuTInfo.bModel
        print   ustr$(eax),13,10

;bExtModel

        print   chr$('    bExtModel: ')
        movzx   eax,byte ptr CpuTInfo.bExtModel
        print   ustr$(eax),13,10

;bType

        print   chr$('        bType: ')
        movzx   eax,byte ptr CpuTInfo.bType
        print   ustr$(eax),13,10

;bStep

        print   chr$('        bStep: ')
        movzx   eax,byte ptr CpuTInfo.bStep
        print   ustr$(eax),13,10

;bMmxBits

        print   chr$('     bMmxBits: ')
        mov     al,CpuTInfo.bMmxBits
        INVOKE  dw2bin_ex,
                eax,
                offset BinBuf
        print   offset BinBuf+24
        print   offset BinTerm

;w3DNowBits

        print   chr$('   w3DNowBits: ')
        mov     ax,CpuTInfo.w3DNowBits
        INVOKE  dw2bin_ex,
                eax,
                offset BinBuf
        print   offset BinBuf+16
        print   offset BinTerm

;wSseBits

        print   chr$('     wSseBits: ')
        mov     ax,CpuTInfo.wSseBits
        INVOKE  dw2bin_ex,
                eax,
                offset BinBuf
        print   offset BinBuf+16
        print   offset BinTerm

;dwMiscBits

        print   chr$('   dwMiscBits: ')
        INVOKE  dw2bin_ex,
                CpuTInfo.dwMiscBits,
                offset BinBuf
        print   offset BinBuf
        print   offset BinTerm

;szBrand

        print   chr$('      szBrand: ')
        print   offset CpuTInfo.szBrand,13,10

;szVendor

        print   chr$('     szVendor: ')
        print   offset CpuTInfo.szVendor,13,10

;szMmx

        print   chr$('        szMmx: ')
        print   offset CpuTInfo.szMmx,13,10

;sz3DNow

        print   chr$('      sz3DNow: ')
        print   offset CpuTInfo.sz3DNow,13,10

;szSse

        print   chr$('        szSse: ')
        print   offset CpuTInfo.szSse,13,10

ExitMain:

        inkey
        exit

_main   ENDP

;--------------------------------------------------------------------------------------------

;############################################################################################

IdCpu   PROC    USES EBX ESI EDI lpCpuTypeInfo:DWORD
;
; ID CPU CORE
; VERSION: E.01, Preliminary
;
; Written by DednDave, December 2009
;
;*********************************************************
;
; Usage:
;
;       mov dword ptr CpuTInfo.cbSize,sizeof CpuTInfo ;set the structure size value
;       mov dword ptr CpuTInfo.dwCoreAffMask,1        ;select core 0
;       INVOKE  IdCpu,offset CpuTInfo                 ;pass the address of the structure
;
;      CpuTInfo = a valid CpuTypeInfo structure
;        cbSize = size of the structure (120 bytes for this version)
; dwCoreAffMask = a bit mask indicating which core to identify
;                 One and only one bit must be set in this value,
;                 selecting core 0 to 31. This version does not
;                 support systems with more than 32 cores.
;
; Notes:
;
;   1) The example shown tests and evaluates CPU core 0.
;   2) See the notes below for information about values
;      returned in registers and in the CpuTInfo structure.
;
;*********************************************************
;
; Register-Returned Values:
;
;   EDX = address of CpuTypeInfo structure
;
;   ECX = size of CpuTypeInfo structure, in bytes
;         If an invalid structure or core is specified, a NULL value is returned.
;
;   EAX = return status
;           This value reflects procedure success or error status. A more detailed status is
;         returned in the CpuTypeInfo.dwIdCpuStatus value. This is done because unidentified or
;         unknown CPUs or CPUs that do not support the CPUID instruction do not necessarily
;         indicate procedure failure. Additionally, there are no MS compatible error codes or
;         messages to reflect many of the possible return conditions. In this version, there
;         are three possible values returned in EAX:
;
;         EAX = 0, ERROR_SUCCESS
;                 The routine completed successfully. This value may be returned even if the
;               CPU core was not present or identified. It simply indicates that a proper
;               structure was passed and identification of a single core was requested. It
;               also indicates that the values returned in the CpuTypeInfo structure are
;               valid and that the dwIdCpuStatus value may be examined to determine further
;               return status information.
;              
;         EAX = 13, ERROR_INVALID_DATA
;                 This status indicates that a valid CpuTypeInfo structure was passed, but the
;               CPU core value specified in the dwCoreAffMask value is invalid (no bits set or
;               more than one bit set). If this value is returned, it also indicates that the
;               values returned in the CpuTypeInfo structure are undefined and invalid.
;
;         EAX = 87, ERROR_INVALID_PARAMETER
;                 This status indicates an error with the CpuTypeInfo structure, itself. Either
;               the cbSize value is invalid or the address plus length causes segment wrap. If
;               this value is returned, it also indicates that the values returned in the
;               CpuTypeInfo structure are undefined and invalid.
;
; Returned CpuTypeInfo Structure Values:
;
;    -    dwIdCpuStatus
;               TBD - I was thinking of placing the routine version number
;               in the low byte and the status in the second byte, unless the
;               selected core is not present (-1) or does not support CPUID (-2).
;               For now, the routine exits with one of the following values:
;
;            If negative:
;               Value      Meaning
;                -1       selected core is not present
;                -2       selected core does not support CPUID
;                         This value may be eliminated in future versions,
;                         as most processors may be identified without CPUID.
;
;            If positive:
;               Bit        Meaning
;                16       1 if CPUID function 00000001h not supported
;                17       1 if CPUID function 80000001h not supported
;
;    -    bVendorID
;               0 = unknown/unidentified
;               1 = Intel
;               2 = AMD
;
;    -    bFamily
;               CPU family number (0-15)
;
;    -    bExtFamily
;               CPU extended family number (0-255)
;
;    -    bModel
;               CPU model number (0-15)
;
;    -    bExtModel
;               CPU extended model number (0-15)
;
;    -    bType
;               CPU type number (0-3)
;
;    -    bStep
;               CPU step number (0-15)
;
;    -    bMmxBits
;               0_1 values come from CPUID function 1
;               8_1 values come from CPUID function 80000001h
;
;               Bit    Source        Description
;
;                0     0_1edx:23     MMX
;                1     8_1edx:22     MMX+    (AMD only)
;
;    -    w3DNowBits
;               8_1 values come from CPUID function 80000001h
;
;               Bit    Source        Description
;
;                0     8_1edx:31     3DNow!  (AMD only)
;                1     8_1edx:30     3DNow!+ (AMD only)
;
;    -    wSseBits
;               0_1 values come from CPUID function 1
;               8_1 values come from CPUID function 80000001h
;
;               Bit    Source        Description
;
;                0     0_1edx:25     SSE
;                1     0_1edx:26     SSE2
;                2     0_1ecx:00     SSE3
;                3     0_1ecx:09     SSSE3
;                4     0_1ecx:19     SSE4.1
;                5     0_1ecx:20     SSE4.2  (Intel only)
;                6     8_1ecx:06     SSE4a   (AMD only)
;                7     8_1ecx:11     SSE5    (AMD only)
;
;    -    dwMiscBits 
;               0_1 values come from CPUID function 1
;               8_1 values come from CPUID function 80000001h
;
;               Bit(s) Source        Name    Description
;
;                 0    0_1 edx:00    FPU     on-chip FPU
;                 1    0_1 edx:01    VME     virtual mode enhancements
;                 2    0_1 edx:02    DE      debug extension
;                 3    8_1 ecx:00    LAHF64  lahf/sahf in 64-bit mode
;                 4    0_1 edx:04    RDTSC   rdtsc instruction
;                 5    8_1 edx:29    LM64    Intel 64/AMD long mode
;                 6    0_1 edx:06    PAE     physical address extension
;                 7    0_1 ecx:23    POPCNT  popcnt instruction
;                 8    0_1 edx:08    CX8     cmpxchg8 instruction
;                 9    0_1 edx:24    FXSR    fxsave/fxrstor instructions
;                10    8_1 edx:11    SYSCALL syscall/sysret instructions
;                11    0_1 edx:11    SEP     sysenter/sysexit instructions
;                12    0_1 edx:28    HTT     hyper-threading technology
;                13    0_1 ecx:13    CX16    cmpxchg16 instruction
;                14                          unused in this version
;                15    0_1 edx:15    CMOV    cmov instructions
;               16-23  0_1 ebx:16-23         total thread count if HTT = 1
;               24-31                        unused in this version
;
;    -    szBrand, szVendor, szMmx, sz3DNow, szSse
;               descriptive strings - all strings are terminated with a space and
;               a zero unless the string is null, in which case no space is added
;
;*********************************************************
;
; Notes:
;
;
;*********************************************************
;
; Future Expansion:
;
; 1) This is only a preliminary version, intended to provide a baseline for development.
; 2) This version identifies only Intel and AMD 80486 processors and later.
;    Future versions may identify older processors and those made by other vendors.
; 3) The L2 cache size should probably be added as a value in the CpuTypeInfo structure,
;    as precise identification of certain specific CPUs may rely on it. Acquiring the
;    complete cache and TLB description is a bit complicated.
; 4) Additional features like ia32, ia64, EM64T, AMD64, HTT, LAHF64, CMPXCHG, etc will
;    be added. We should also indicate the current 32/64 mode for 64-bit processors.
; 5) Cores in package will be added. We may enumerate physical/logical cores seperately.
; 6) For processors that do not provide a brand string, one may be created using the
;    information in the family/extended family/model/extended model/type/step values.
;
;*********************************************************
;
; Data Definition Address TEXTEQU's
;
;*********************************************************

;In this release, we do not use a stack frame for local/temporary data.
;Instead, we use the CpuTypeInfo.szBrand space (50 bytes) as a temporary data area.
;It is easy enough to wait until the end of the routine to fill in the brand string.
;Also, to simplify future modification, we use TEXTEQU's to label data items.

;EDI holds the base address of the CpuTypeInfo structure during most of the procedure

_cbSize        TEXTEQU <[EDI]>           ;structure size in bytes (input)
_dwCoreAffMask TEXTEQU <[EDI+4]>         ;selected core affinity mask (input)
_dwIdCpuStatus TEXTEQU <[EDI+8]>         ;cpu core identification status
_bVendorID     TEXTEQU <[EDI+12]>        ;vendor ID number
_bFamily       TEXTEQU <[EDI+13]>        ;cpu family
_bExtFamily    TEXTEQU <[EDI+14]>        ;cpu extended family
_bModel        TEXTEQU <[EDI+15]>        ;cpu model
_bExtModel     TEXTEQU <[EDI+16]>        ;cpu extended model
_bType         TEXTEQU <[EDI+17]>        ;cpu type
_bStep         TEXTEQU <[EDI+18]>        ;cpu step
_bMmxBits      TEXTEQU <[EDI+19]>        ;MMX bits
_w3DNowBits    TEXTEQU <[EDI+20]>        ;3DNow bits
_wSseBits      TEXTEQU <[EDI+22]>        ;SSE bits
_dwMiscBits    TEXTEQU <[EDI+24]>        ;misc bits
_szBrand       TEXTEQU <[EDI+28]>        ;brand string (50 bytes)
_szVendor      TEXTEQU <[EDI+78]>        ;vendor string (14 bytes)
_szMmx         TEXTEQU <[EDI+92]>        ;MMX string (8 bytes)
_sz3DNow       TEXTEQU <[EDI+100]>       ;3DNow string (10 bytes)
_szSse         TEXTEQU <[EDI+110]>       ;SSE string (10 bytes)

_hProc         TEXTEQU <_szBrand>        ;process handle
_PrcAffMask    TEXTEQU <_szBrand[4]>     ;process affinity mask
_SysAffMask    TEXTEQU <_szBrand[8]>     ;system affinity mask
_r0_1eax       TEXTEQU <_szBrand[12]>    ;cpuid function 00000001h EAX
_r0_1ebx       TEXTEQU <_szBrand[16]>    ;cpuid function 00000001h EBX
_r0_1ecx       TEXTEQU <_szBrand[20]>    ;cpuid function 00000001h ECX
_r0_1edx       TEXTEQU <_szBrand[24]>    ;cpuid function 00000001h EDX
_r8_0eax       TEXTEQU <_szBrand[28]>    ;cpuid function 80000000h EAX
_r8_1ecx       TEXTEQU <_szBrand[32]>    ;cpuid function 80000001h ECX
_r8_1edx       TEXTEQU <_szBrand[36]>    ;cpuid function 80000001h EDX

;*********************************************************
;
; Validate Structure Address and Size Parameters
;
;*********************************************************

        mov     edi,lpCpuTypeInfo
        mov     eax,_cbSize
        cmp     eax,120
        jnz     Error0                   ;error - invalid parameter

        mov     edx,eax
        dec     eax
        add     eax,edi
        jc      Error0                   ;error - invalid parameter

;*********************************************************
;
; Validate Core Selection Value
;
;*********************************************************

;validate the core mask value

;EDX = _cbSize
;EDI = address of CpuTypeInfo structure

        mov     eax,_dwCoreAffMask
        mov     esi,eax
        dec     eax
        xor     eax,esi
        inc     eax
        shr     eax,1                    ;must be at least one bit
        jz      Error1                   ;error - invalid data

        cmp     eax,esi                  ;must not be more than one bit
        jnz     Error1                   ;error - invalid data

;zero the structure (except input values)

;EDX = _cbSize
;ESI = selected core affinity mask
;EDI = address of CpuTypeInfo structure

        lea     ebx,[edi+8]
        sub     edx,8                    ;do not zero the input values
        mov     ecx,edx
        and     edx,-4
        sub     ecx,edx
        xor     eax,eax
        shr     edx,2

Zero00: mov     [ebx],eax
        add     ebx,4
        dec     edx
        jnz     Zero00

        jecxz   Zero02

Zero01: mov     [ebx],al
        inc     ebx
        dec     ecx
        jnz     Zero01

;get and save the original affinity masks

Zero02: INVOKE  GetCurrentProcess
        mov     _hProc,eax
        lea     ecx,_PrcAffMask
        lea     edx,_SysAffMask
        INVOKE  GetProcessAffinityMask,
                eax,
                ecx,
                edx

;verify the selected core exists

        test    esi,_SysAffMask
        jnz     Cpuid0

;*********************************************************
;
; Status Exits
;
;*********************************************************

;status - core not present

        push    -1
        jmp short Sttus1

;status - cpuid not supported

Sttus0: push    -2

;status exit

Sttus1: pop     _dwIdCpuStatus
        jmp     RExit0

;*********************************************************
;
; Error Exits
;
;*********************************************************

;error - invalid parameter

Error0: push    87                       ;ERROR_INVALID_PARAMETER
        jmp short Error2

;error - invalid data

Error1: push    13                       ;ERROR_INVALID_DATA

;error exit

Error2: xor     ecx,ecx
        mov     edx,edi
        pop     eax
        jmp     RExit1

;*********************************************************
;
; Verify CPUID Support for the Specified Core
;
;*********************************************************

Cpuid0: INVOKE  SetProcessAffinityMask,
                _hProc,
                esi
        pushfd
        pop     eax
        mov     edx,eax                  ;edx=original
        xor     eax,200000h              ;eax=toggled
        push    eax
        popfd                            ;eflags=new
        pushfd
        pop     eax                      ;eax=new
        push    edx
        popfd                            ;eflags=original
        xor     eax,edx                  ;eax=toggle result
        test    eax,200000h
        jz      Sttus0                   ;status - cpuid not supported

;*********************************************************
;
; Read and Store the Feature Register Values
;
;*********************************************************

        xor     eax,eax
        cpuid
        mov     _szVendor,ebx
        mov     _szVendor[4],edx
        mov     _szVendor[8],ecx
        push    1
        or      eax,eax
        pop     eax
        jnz     Feat00

        mov     _dwIdCpuStatus+1,al      ;status - 0_1 features not supported
        jmp short Feat01

Feat00: cpuid
        mov     _r0_1eax,eax
        mov     _r0_1ebx,ebx
        mov     _r0_1ecx,ecx
        mov     _r0_1edx,edx

Feat01: mov     eax,80000000h
        push    eax
        cpuid
        pop     edx
        mov     _r8_0eax,eax
        inc     edx                      ;EDX = 80000001h
        cmp     eax,edx
        jae     Feat02

        or byte ptr _dwIdCpuStatus+1,2   ;status - 8_1 features not supported
        jmp short Feat03

Feat02: xchg    eax,edx                  ;EAX = 80000001h
        cpuid
        mov     _r8_1ecx,ecx
        mov     _r8_1edx,edx

Feat03: INVOKE  SetProcessAffinityMask,
                _hProc,
                _PrcAffMask

;*********************************************************
;
; Fill the CpuTypeInfo Structure (Except Brand String)
;
;*********************************************************

;vendor id number and vendor specific bit masks

        push    2
        mov     ebx,0FFEFFFFFh           ;AMD _r0_1ecx mask
        mov     eax,_szVendor[8]
        mov     ecx,0FFFFFFFFh           ;AMD _r8_1ecx mask
        mov     esi,0FFFFFFFFh           ;AMD _r8_1edx mask
        cmp     eax,444D4163h            ;is it AMD ?
        pop     edx
        jz      Bits00

        mov     ebx,0FFFFFFFFh           ;Intel _r0_1ecx mask
        mov     ecx,0FFFFF7BFh           ;Intel _r8_1ecx mask
        mov     esi,03FBFFFFFh           ;Intel _r8_1edx mask
        dec     edx
        cmp     eax,6C65746Eh            ;is it Intel ?
        jz      Bits00

        dec     edx
        mov     ebx,0FFEFFFFFh           ;unidentified _r0_1ecx mask

Bits00: mov     _bVendorID,dl
        and     _r0_1ecx,ebx
        and     _r8_1ecx,ecx
        and     _r8_1edx,esi

;family/extended family/model/extended model/type/step

        mov     eax,_r0_1eax
        mov     edx,eax
        and     ax,0F0Fh
        mov     _bStep,al
        mov     _bFamily,ah
        shr     edx,4
        mov     eax,edx
        and     ax,30Fh
        mov     _bModel,al
        mov     _bType,ah
        shr     edx,12
        mov     eax,edx
        and     al,0Fh
        mov     _bExtModel,al
        shr     edx,4
        mov     _bExtFamily,dl

;dwMiscBits miscellaneous bits

;Bit(s) Source       Name    Description
;
;  0    _r0_1edx:00  FPU     on-chip FPU
;  1    _r0_1edx:01  VME     virtual mode enhancements
;  2    _r0_1edx:02  DE      debug extension
;  3    _r8_1ecx:00  LAHF64  lahf/sahf in 64-bit mode
;  4    _r0_1edx:04  RDTSC   rdtsc instruction
;  5    _r8_1edx:29  LM64    Intel 64/AMD long mode
;  6    _r0_1edx:06  PAE     physical address extension
;  7    _r0_1ecx:23  POPCNT  popcnt instruction
;  8    _r0_1edx:08  CX8     cmpxchg8 instruction
;  9    _r0_1edx:24  FXSR    fxsave/fxrstor instructions
; 10    _r8_1edx:11  SYSCALL syscall/sysret instructions
; 11    _r0_1edx:11  SEP     sysenter/sysexit instructions
; 12    _r0_1edx:28  HTT     hyper-threading technology
; 13    _r0_1ecx:13  CX16    cmpxchg16 instruction
; 14                         unused in this version
; 15    _r0_1edx:15  CMOV    cmov instructions
;16-23  _r0_1ebx:16-23       total thread count if HTT = 1
;24-31                       unused in this version

        mov     edx,_r0_1edx
        mov     eax,edx
        and     eax,8957h
        test    edx,10000000h            ;HTT bit set ?
        jz      Misc00                   ;no - skip HTT

        mov     ebx,_r0_1ebx
        and     ebx,0FF0000h             ;total thread count
        mov     bh,10h                   ;set HTT bit
        or      eax,ebx

Misc00: test    edx,1000000h             ;FXSR bit set ?
        jz      Misc01

        or      ah,2                     ;set FXSR bit

Misc01: mov     edx,_r0_1ecx
        test    edx,800000h              ;POPCNT bit set ?
        jz      Misc02

        or      al,80h                   ;set POPCNT bit

Misc02: and     dh,20h                   ;CX16 bit
        or      ah,dh
        mov     edx,_r8_1edx
        shr     edx,1
        and     dh,4
        or      ah,dh
        test    edx,10000000h            ;LM64 bit set ?
        jz      Misc03

        or      al,20h                   ;set LM64 bit

Misc03: mov     edx,_r8_1ecx
        and     dl,1                     ;LAHF64 bit
        shl     edx,3
        or      al,dl
        mov     _dwMiscBits,eax

;mmx bits and string

; _r0_1edx:23  MMX
; _r8_1edx:22  MMX+    (AMD only)

        mov     eax,_r0_1edx
        mov     edx,_r8_1edx
        shr     eax,2
        and     eax,200000h
        or      eax,edx
        shr     eax,21
        and     eax,3
        jz      B3DN00

        mov     ebx,2B584D4Dh            ;'MMX+'
        mov     _bMmxBits,ax
        test    al,2
        jnz     Mmx000

        and     ebx,0FFFFFFh

Mmx000: mov     _szMmx,ebx

;3dnow bits and string

; _r8_1edx:31  3DNow!  (AMD only)
; _r8_1edx:30  3DNow!+ (AMD only)

B3DN00: shl     edx,1
        rcl     eax,1
        rol     edx,1
        shl     edx,1
        and     al,1
        or      al,dl
        and     eax,3
        jz      Sse000

        mov     _w3DNowBits,ax
        mov dword ptr _sz3DNow,6F4E4433h ;'3DNo'
        mov     edx,2B2177h              ;'w!+'
        test    al,2
        jnz     B3DN01

        and     edx,0FFFFh

B3DN01: mov     _sz3DNow+4,edx

;sse bits and string

; _r0_1edx:25  SSE
; _r0_1edx:26  SSE2
; _r0_1ecx:00  SSE3
; _r0_1ecx:09  SSSE3
; _r0_1ecx:19  SSE4.1
; _r0_1ecx:20  SSE4.2  (Intel only)
; _r8_1ecx:06  SSE4a   (AMD only)
; _r8_1ecx:11  SSE5    (AMD only)

Sse000: mov     eax,_r0_1edx
        mov     edx,_r0_1ecx
        shr     eax,25
        and     eax,3
        test    dl,1                     ;SSE3 bit set ?
        jz      Sse001

        or      al,4                     ;set SSE3 bit

Sse001: test    dh,2                     ;SSSE3 bit set ?
        jz      Sse002

        or      al,8                     ;set SSSE3 bit

Sse002: test    edx,80000h               ;SSE4.1 bit set ?
        jz      Sse003

        or      al,10h                   ;set SSE4.1 bit

Sse003: test    edx,100000h              ;SSE4.2 bit set ?
        jz      Sse004

        or      al,20h                   ;set SSE4.2 bit

Sse004: mov     edx,_r8_1ecx
        test    dl,40h                   ;SSE4a bit set ?
        jz      Sse005

        or      al,40h                   ;set SSE4a bit

Sse005: test    dh,8                     ;SSE5 bit set ?
        jz      Sse006

        or      al,80h                   ;set SSE5 bit

Sse006: or      eax,eax
        jz      Brand0

        mov     _wSseBits,ax
        mov word ptr _szSse,5353h        ;'SS'
        mov     edx,3545h                ;'E5'
        test    al,80h
        jnz     Sse007

        mov     edx,613445h              ;'E4a'
        test    al,40h
        jnz     Sse007

        mov     edx,322E3445h            ;'E4.2'
        test    al,20h
        jnz     Sse007

        mov     edx,312E3445h            ;'E4.1'
        test    al,10h
        jnz     Sse007

        mov     edx,334553h              ;'SE3'
        test    al,8
        jnz     Sse007

        shr     edx,8                    ;'E3'
        test    al,4
        jnz     Sse007

        mov     dh,32h                   ;'E2'
        test    al,2
        jnz     Sse007

        mov     dh,0                     ;'E'

Sse007: mov     _szSse+2,edx

;*********************************************************
;
; Fill the CpuTypeInfo Structure Brand String
;
;*********************************************************

;save the required values in register and zero the string

Brand0: xor     eax,eax
        push    12
        mov     ebx,_hProc
        mov     edx,_PrcAffMask
        pop     ecx
        mov     esi,_r8_0eax
        push    edi
        add     edi,28                   ;point to the brand string

Brand1: mov     [edi],eax
        add     edi,4
        dec     ecx
        jnz     Brand1

;see if the brand string is supported

        cmp     esi,80000004h
        pop     edi
        jb      Strng0

;get and store the brand string

        push    edi
        push    ebx
        push    edx
        INVOKE  SetProcessAffinityMask,
                eax,
                _dwCoreAffMask
        add     edi,28                   ;point to the brand string
        mov     eax,80000002h

Brand2: push    edi
        push    eax
        cpuid
        mov     [edi],eax
        mov     [edi+4],ebx
        mov     [edi+8],ecx
        mov     [edi+12],edx
        pop     eax
        inc     eax
        pop     edi
        add     edi,16
        cmp     al,5
        jb      Brand2

        pop     edx
        pop     eax
        INVOKE  SetProcessAffinityMask,
                eax,
                edx
        pop     edi

;*********************************************************
;
; Strip Leading Spaces from szBrand and szVendor Strings
;
;*********************************************************

Strng0: xor     eax,eax
        push    edi
        push    eax
        add     edi,28                   ;point to first byte of _szBrand
        push    edi
        add     edi,50                   ;point to first byte of _szVendor
        push    edi

Strng1: pop     ecx
        jecxz   STerm0

        mov     edi,ecx
        jmp short Strng3

Strng2: inc     ecx

Strng3: mov     al,[ecx]
        or      al,al
        jz      Strng5

        cmp     al,20h
        jz      Strng2

        jmp short Strng5

Strng4: mov     al,[ecx]

Strng5: mov     [edi],al
        inc     ecx
        inc     edi
        or      al,al
        jnz     Strng4

        jmp     Strng1

;*********************************************************
;
; Terminate the Strings
;
;*********************************************************

;terminate szBrand, szVendor, szMmx, sz3DNow, szSse
;we locate the last non-white-space charater in each string
;if it is a null string, we simply place a 0 byte
;otherwise we place a space, then a 0 byte

STerm0: pop     edi
        xor     eax,eax
        push    eax
        add     edi,77                   ;point to last byte of _szBrand
        mov     al,14                    ;sizeof _szVendor
        push    edi
        push    50                       ;sizeof _szBrand
        add     edi,eax
        push    edi
        push    eax
        mov     al,8                     ;sizeof _szMmx
        add     edi,eax
        push    edi
        push    eax
        mov     al,10                    ;sizeof _sz3DNow and _szSse
        add     edi,eax
        push    edi
        push    eax
        add     edi,eax
        push    edi
        push    eax
        mov     al,20h                   ;space
        mov     dl,0DFh                  ;mask space/null

STerm1: pop     ecx
        jecxz   RExit0

        pop     edi

STerm2: test    dl,[edi]
        jnz     STerm3

        dec     edi
        dec     ecx
        jnz     STerm2

        mov     [edi+1],ah
        jmp     STerm1

STerm3: mov     [edi+1],ax
        jmp     STerm1

;*********************************************************
;
; Set Register-Returned Values and Exit Routine
;
;*********************************************************

RExit0: mov     edx,lpCpuTypeInfo
        xor     eax,eax
        mov     ecx,[edx]

RExit1: ret

IdCpu   ENDP

;############################################################################################

        END     _main

